<template>
  <div>
    <h1 class="mb-3">What happens next?</h1>
    <p class="mb-6 text-base">On the following screens we’ll collect information about your health and medical history. We’ll never share your information.</p>
    <p class="mb-6 text-base">A doctor wil review and reach out to you to complete your consultation.</p>
    <div class="grid gap-y-3 mb-8">
      <div class="grid grid-cols-2 gap-x-2">
        <text-input
          label="Legal First Name"
          v-model="selected.firstName"
          :error-message="getErrorMessage('firstName')"
        />
        <text-input
          label="Legal Last Name"
          v-model="selected.lastName"
          :error-message="getErrorMessage('lastName')"
        />
      </div>
      <text-input
        label="Email Address"
        type="email"
        v-model="selected.email"
        :error-message="getErrorMessage('email')"
      />
      <text-input
        label="Create Password"
        type="password"
        v-model="selected.password"
        :error-message="getErrorMessage('password')"
      />
    </div>
    <common-btn
      text="Start my free visit"
      @click="handleClick"
    />
  </div>
</template>

<script>
import {answersMixin, offerMixin} from "@/utils/mixins";

import {required, email} from 'vuelidate/lib/validators'
import {constants} from "@/constants";

export default {
  mixins: [answersMixin, offerMixin],
  name: "TheBasics2",
  validations: {
    selected: {
      firstName: {required},
      lastName: {required},
      email: {required, email},
      password: {required},
    }
  },
  watch: {
    selected: {
      handler(newVal) {
        this.setAnswer(this.answersKeys.THE_BASICS, newVal, 'stage_2')
      },
      deep: true
    }
  },
  beforeDestroy() {
    this.SET_OFFER_TEXT(null)
  },
  mounted() {
    this.SET_OFFER_TEXT(constants.MONEY_BACK_GUARANTEE)
  },
  data() {
    return {
      selected: {
        firstName: null,
        lastName: null,
        email: null,
        password: null,
      }
    }
  },
  methods: {
    getErrorMessage(field) {
      let msg = null
      const isInvalid = this.$v.selected[field].$invalid && this.$v.selected[field].$dirty

      if (isInvalid) {
        msg = 'Please fill this field'

        if (field === 'email' && !this.$v.selected[field].email) {
          msg = 'Please enter valid email'
        }
      }

      return msg
    },
    handleClick() {
      this.$v.$touch()
      if (!this.$v.$invalid) {
        this.$emit('nextStage')
      }
    },
  }
}
</script>

<style scoped>

</style>
